// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{Bin, DockRevealer};
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlDockBinEdge")]
    pub struct DockBinEdge(Object<ffi::DzlDockBinEdge, ffi::DzlDockBinEdgeClass>) @extends DockRevealer, Bin, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_dock_bin_edge_get_type(),
    }
}

impl DockBinEdge {
    pub const NONE: Option<&'static DockBinEdge> = None;
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::DockBinEdge>> Sealed for T {}
}

pub trait DockBinEdgeExt: IsA<DockBinEdge> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_dock_bin_edge_get_edge")]
    #[doc(alias = "get_edge")]
    fn edge(&self) -> gtk::PositionType {
        unsafe {
            from_glib(ffi::dzl_dock_bin_edge_get_edge(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn set_edge(&self, edge: gtk::PositionType) {
        ObjectExt::set_property(self.as_ref(), "edge", edge)
    }

    #[doc(alias = "move-to-bin-child")]
    fn connect_move_to_bin_child<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn move_to_bin_child_trampoline<
            P: IsA<DockBinEdge>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlDockBinEdge,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockBinEdge::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"move-to-bin-child\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    move_to_bin_child_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    fn emit_move_to_bin_child(&self) {
        self.emit_by_name::<()>("move-to-bin-child", &[]);
    }

    #[doc(alias = "edge")]
    fn connect_edge_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_edge_trampoline<P: IsA<DockBinEdge>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlDockBinEdge,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockBinEdge::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::edge\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_edge_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<DockBinEdge>> DockBinEdgeExt for O {}

impl fmt::Display for DockBinEdge {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("DockBinEdge")
    }
}
